package com.steerinfo.baseinfo.meterbasemattermap.controller;

import com.steerinfo.baseinfo.meterbasecar.model.MeterBaseCar;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasemattermap.model.MeterBaseMatterMap;
import com.steerinfo.baseinfo.meterbasemattermap.service.IMeterBaseMatterMapService;
import com.steerinfo.meterwork.meterworkprewgttype.mapper.MeterWorkPreWgttypeMapper;
import com.steerinfo.meterwork.meterworkprewgttype.model.MeterWorkPreWgttype;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseMatterMap RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-08-30 09:28
 * 类描述
 * 修订历史：
 * 日期：2022-08-30
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterMap RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasemattermaps")
public class MeterBaseMatterMapController extends BaseRESTfulController {

    @Resource
    IMeterBaseMatterMapService meterBaseMatterMapService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasemattermap:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterMap> list = meterBaseMatterMapService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasemattermap:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterMap> list = meterBaseMatterMapService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseMatterMap对象创建")
    @ApiImplicitParam(name = "meterBaseMatterMap", value = "详细实体meterBaseMatterMap", required = true, dataType = "MeterBaseMatterMap")
    //@RequiresPermissions("meterbasemattermap:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseMatterMap model){
        MeterBaseMatterMap meterBaseMatterMap = meterBaseMatterMapService.add(model);
        return success(meterBaseMatterMap);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasemattermap:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseMatterMap meterBaseMatterMap = meterBaseMatterMapService.getById(id);
        return success(meterBaseMatterMap);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseMatterMap信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseMatterMap", value = "详细实体meterBaseMatterMap", required = true, dataType = "MeterBaseMatterMap")
    })
    //@RequiresPermissions("meterbasemattermap:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterMap model){
        model.setId(id);
        MeterBaseMatterMap meterBaseMatterMap = meterBaseMatterMapService.modify(model);
        return success(meterBaseMatterMap);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasemattermap:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseMatterMapService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseMatterMap信息来更新详细信息")
    @PostMapping(value = "/isDoublePre", produces  = "application/json;charset=UTF-8")
    public RESTfulResult isDoublePre(@RequestBody MeterBaseCar model){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterBaseMatterMapService.isDoublePre(model.getCarNo());
            return rm;
        }catch (Exception e){
            rm.setCode("500");
            rm.setSucceed(false);
            rm.setData(null);
            rm.setMessage("操作失败--》" + e.getMessage());
            e.printStackTrace();
            return rm;
        }
    }
}
